# Changelog
All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/)
and this project adheres to [Semantic Versioning](http://semver.org/).

## 1.14.0 - 2020-06-17
## Added
- Route school_location
- Route mesoregion
- Route microregion
## Changed
- City route now returns microregion_id and mesoregion_id
- Update classCount base filters
- Update classroom base query
- Update classroomCount base filters in school
- Removed addMissing from cub route
- Changed dailyChargeAmount filter pattern
- Enrollment now has mesoregion/microregion dims/filters
- Changed reqFilters in outOfSchool route
- School now has mesoregion/microregion dims/filters
- Teacher now has mesoregion/microregion dims/filters
- UnivesityEnrollment now has mesoregion/microregion dims/filters

## 1.13.4 - 2020-06-05
- Arrangment filter in school indicator 2007-2019
- Employees Indicator 2007-2019

## 1.13.3 - 2020-05-21

## 1.13.2 - 2020-05-21
## Changed
- Rename rural category

## 1.13.1 - 2020-05-12
## Changed
- Fix dot error

## 1.13.0 - 2020-04-XX
## Added
- Added 2019 data
- Added Goverment agreement in school
- Added Arrangment dims in school
## Changed
- Updated 2007-2018
- Updated education level mod
- Updated adm_dependency_detailed filter
- Updated rural_location filter
- Updated period labels
- AddMissing will now force ordination by id
- Updated all routes to contain id in region, state and city dims

## 1.12.6 - 2020-02-02
## Changed
- Fix teacher education mod dimension
- Fix text

## 1.12.5 - 2020-01-27
## Changed
- Fix duplicated cities in courseCount

## 1.12.4 - 2020-01-27
## Changed
- Fix addMissing

## 1.12.3 - 2019-12-20
## Changed
- Fix new categories in education type for teacher

## 1.12.2 - 2019-12-19
## Changed
- Fix addMissing
- Add new categories in education type for teacher

## 1.12.1 - 2019-12-12
## Changed
- Added categories to adm dependency

## 1.12.0 - 2019-11-25
## Changed
- Add teacher count to classroom_count route

## 1.11.17 - 2019-10-08
## Changed
- Fix query\_exec

## 1.11.16 - 2019-10-30
## Changed
- University Teacher updated

## 1.11.15 - 2019-10-16
## Changed
- Fix addMissing for classCount route

## 1.11.14 - 2019-10-13
## Changed
- OCDE updated

## 1.11.13 - 2019-09-11
## Changed
- Classroom with dim location and city filter, will always return both locations

## 1.11.12 - 2019-09-10
## Changed
- Changed classroom filters to match classroomCount

## 1.11.11 - 2019-09-09
## Changed
- Changed classroomCount filters

## 1.11.10 - 2019-08-23
## Changed
- Removed year limitation
- Updated existing variables

## 1.11.9 - 2019-07-25
## Changed
- Course count order fix
- Course count missing fix

## 1.11.8 = 2019-07-19
## Changed
- Remove /user route

## 1.11.7 - 2019-07-12
## Changed
- EnrollmentProjection now returns empty values with 0

## 1.11.6 - 2019-07-11
## Changed
- Return haveSportsCourtCoverage and haveCourtyardCoverage = [] in route school_infrastructure 

## 1.11.5 - 2019-07-09
## Changed
 - Fix integral time
 - Fix match queries in school_infrastructure

## 1.11.4 - 2019-06-17
## Changed
- Changed enrollment variable
- Added location and latitude to state and city
- Changed courseCount variables
- Removed 'Not classified' from teacher

## 1.11.3 - 2019-06-17
## Changed
- Changed variables from university
- Removed year limitation from university

## 1.11.2 - 2019-06-17
## Changed
- transport now uses an aggregate table

## 1.11.1 - 2019-06-10
## Changed
- ClassroomCount now uses an aggregate table

## 1.11.0 - 2019-05-24
## Changed
- Add university teacher indicator for 2017

## 1.10.5 - 2019-05-23
## Changed
- Revert api.js

## 1.10.4 - 2019-05-23
## Changed
- Fix order in enrollment indicator
## Added
- Added university enrollment indicator
- Added course count indicator

## 1.10.3 - 2019-05-22
## Changed
- Fix schoolInfrastructure.js

## 1.10.2 - 2019-05-10
## Changed
- Fix api.js

## 1.10.0 - 2019-05-10
## Added
- Added university indicator

## 1.9.8 - 2019-08-02
## Changed
- Fix bug duplicate city name in classroom count

## 1.9.7 - 2019-05-02
## Changed
- Fix enrollment projection
- Fix enrollment number in classroom count
- Fix error in class count

## 1.9.6 - 2019-04-02
## Changed
- Fix null in integral time

## 1.9.5 - 2019-03-15
## Changed
- Fix join's in class count route

## 1.9.4 - 2019-03-12
## Changed
- Change docente.id to docente.id_docente

## 1.9.3 - 2019-03-12
## Changed
- Fix addMissing function

## 1.9.2 - 2019-02-20
## Changed
- Fix location variable in table

## 1.9.1 - 2019-02-14
## Changed
- Fix join's in financial route

## 1.9.0 - 2018-11-24
## Changed
- Fix school infrastructure results when partial or needed schools query return empty
- Block 2 or more dimensions in daily_charge_amount/average

## 1.8.3 - 2018-11-24
### Changed
- Fixed reulst return in classroom count

## 1.8.2 - 2018-11-23
### Changed
- Fixed class count route
- Fixed classroom count school year bug

## 1.8.1 - 2018-11-13
### Changed
- Fixed bug in id2str with inexistent convert function

## 1.8.0 - 2018-11-13
### Added
- Add financial route
- Add employees route
### Changed
- Fix school route
- Fix transport route
- Fix return where integral time is null
- Classroom count route returns school year results for education level 1

## 1.7.0 - 2018-09-20
### Changed
- Fix return string in contract type id 1
- Fix out of school route
- Fix pib-per-capita route
- Fix filters in infrastructure route
- Remove filters in transport route

## 1.6.1 - 2018-08-23
### Changed
- Fix return json name in transport route

## 1.6.0 - 2018-08-17
### Added
- Dimension state in route `enrollment` now returns state name and id
- `school` route now has a `search` parameter. You can search by city name or state abbreviation
- Added all age range convertion
- Added special class and all age range to id2str
- Added `school infratructure` route
- Added `INEP` route for Portal MEC
### Changed
- Fix `auxiliar` indicator
- Add property "don't group" in RQF to dismiss the group by and order by clause
- Change RQF filters in `auxiliar` route
- Fix total classrooms needed bug in classroom count
- Add special class and all age range to enrollment route

## 1.5.0 - 2018-07-30
### Added
- Add portaMec route
- Fix bug in diagnosis and projection routes

## 1.4.2 - 2018-07-23
### Added
- Added new url's in daily charge amount indicator
### Changed
- Fix variable name and url in daily charge amount indicator

## 1.4.1 - 2018-07-03
### Changed
- Fix duplicate in transport indicator

## 1.4.0 - 2018-06-27
### Added
- Add school building filter/dimension to school count route
- Add transport indicator
- Add cub route
### Changed
- Fixed CSV output when result objects have nested arrays and/or objects
- Limit year range to 2007-2015 in out of school indicator
- Fix auxiliar indicator

## 1.3.3 - 2018-06-27
### Changed
- Removed restriction of year > 2014 of school count route

## 1.3.2 - 2018-06-20
### Changed
- Fixed math error in classroom count at total classroom needed expression

## 1.3.1 - 2018-06-19
### Changed
- Fixed bug with Federal District and missing cities in classroom count

## 1.3.0 - 2018-06-18
### Added
- Daily charge amount route

## 1.2.3 - 2018-06-14
### Changed
- Fixed roundig error in classroom count route
- Route performance improved

## 1.2.2 - 2018-05-22
### Changed
- Fixed bug with missing education levels in classroom count

## 1.2.1 - 2018-05-22
### Changed
- Add state id in infrastructure

## 1.2.0 - 2018-05-21
### Added
- Classroom count route

## 1.1.1 - 2018-05-10
### Changed
- Fix bug in gloss enrollment ratio route
- Fix bug in liquid enrollment ratio route

## 1.1.0 - 2018-05-02
### Added
- Out of school population indicator
- Liquid enrollment ratio indicator
- Gloss enrollment ratio indicator

## 1.0.3 - 2018-04-27
### Changed
- Fixed bug undefined field in some indicators

## 1.0.2 - 2018-04-18
### Changed
- Fixed bug in pibpercapita route

## 1.0.1 - 2018-03-15
### Changed
- Fix missing school id in teacher and class routes

## 1.0.0 - 2018-03-14
### Added
- `ReqQueryFields` middleware added to substitute parseParams and do SQL building automagically with the URL params
- Upgrade to database v2
- Added user model
- Passport.js added for user authentication
- Added routes to create and authenticate a user
- Added simulation model
- Added routes to save and retrieve simulations in `/simulation`
- Add middleware to convert ids to names

### Changed
- Query middleware throws a 404 when the result is empty
- Change filters and dimensions names! No more `_id`. **Breaks compability**
- config.json.example now has values for development, test and production environments
- Min Node version is 6.8.1
- Cache is now defined per route
- Errors from MonetDB are now returned by the query_exec and query middlewares
- Tests are now in different files

### Removed
- Parse Params middleware removed

## 0.1.0 - 2016-10-10
### Added
**Database**
- MonetDB connection middleware
- MongoDB connection middleware
- query_exec custom middleware (promise that executes an SQL query with optional parameters)
- This version depends on the version 0.1.0 of [MonetDB schema](https://gitlab.c3sl.ufpr.br/simcaq/monetdb)

**Enrollments**
- Enrollments route with all sub dependencies

**Middlewares**
- parseParams middleware to parse HTTP GET params
- query middleware that serves as an interface between squel generated sql and the query execution
- response middleware that gives a standard response (json, csv or xml)
